﻿Public Class Persoon
    Public Sub New(aNaam As String)
        If String.IsNullOrEmpty(aNaam) Then
            Throw New ArgumentNullException("aNaam", "Naam mag niet leeg zijn")
        End If
        _Naam = aNaam
    End Sub
    Public ReadOnly Property Naam As String
    Private _Geboortedatum As DateTime
    Public Property Geboortedatum As DateTime
        Get
            Return _Geboortedatum
        End Get
        Set(value As DateTime)
            If value > DateTime.Today Then
                Throw New ArgumentException("Geboortedatum kan niet in de toekomst liggen")
            End If
            _Geboortedatum = value
        End Set
    End Property
    Public ReadOnly Property Leeftijd As Integer
        Get
            Return BerekenLeeftijd()
        End Get
    End Property
    Private Function BerekenLeeftijd()
        Dim vandaag As DateTime = DateTime.Today
        Dim leeftijd As Integer = vandaag.Year - Geboortedatum.Year
        Dim verjaardag As DateTime = New DateTime(vandaag.Year, Geboortedatum.Month, Geboortedatum.Day)
        If verjaardag > vandaag Then leeftijd -= 1
        Return leeftijd
    End Function
End Class
